{**********************************}
{        PROGRAM TRANZYST          }
{     AUTOR:DAWID CIESZYSKI       }
{          WERSJA:1.1              }
{  OSTATNIA MODYFIKACJA:10.8.2002  }
{  PROGRAM SUY DO KATALOGOWANIA  }
{    TRANZYSTORW BIPOLARNYCH      }
{      W PLIKU TRANZYST.DAT        }
{**********************************}
{Copyright Dawid Cieszak Cieszyski
dkc@o2.pl
http://www.cieszak.prv.pl
http://cieszak.private.pl
}

uses mousecrt,crt,keyboard,advhsc;
type
    Ttyp=string[3];
    Tsymbol=string[10];
    Tfirma=string[10];
    Tobudowa=string[5];
    Tnapiecie=word;
    Tprad=real;
    Tmoc=real;
    Tczestotliwosc=real;
    Tcena=real;
    Tzaznaczenie=boolean;
    Ttranzystor=record
                         symbol           :Tsymbol;
                         typ              :Ttyp;
                         napiecie         :Tnapiecie;
                         prad             :Tprad;
                         moc              :Tmoc;
                         czestotliwosc    :Tczestotliwosc;
                         obudowa          :Tobudowa;
                         cena             :Tcena;
                         firma            :Tfirma;
                         zaznaczenie      :Tzaznaczenie
                   end;
var
   plik:file of Ttranzystor;    {tranzyst.dat}
   x,y,klawisz:byte;            {zmienne myszy}
   tranzystor:Ttranzystor;      {zmienna uywana do zapisu i odczytu pliku}
   tranzystornumer:longint;     {numer pierwszego wywietlanego tranzystora}

procedure clear;{czyszczenie ekranu}
var a:word;
begin
     for a:=1 to 25 do textcenter(1,a,80,' ',white) ;
end;

function mouseclick(var klawisz,x,y:byte):boolean;{czeka na uycie myszy}
var pom:boolean;
begin
     pom:=false;
     while mouseused(klawisz,x,y) do pom:=true;
     mouseclick:=pom
end;

procedure clearkeyboard;{czyszczenie bufora klawiaury}
var a:char;
begin
     while keypressed do a:=readkey
end;

procedure dc;{znak graficzny}
begin
     clearkeyboard;
     clear;
     setrbackcolor(1,1,16,8,black);
     setrbackcolor(1,9,16,17,blue);
     setrbackcolor(1,18,16,25,red);
     setrbackcolor(17,1,32,8,red);
     setrbackcolor(17,9,32,17,black);
     setrbackcolor(17,18,32,25,blue);
     setrbackcolor(33,1,48,8,blue);
     setrbackcolor(33,9,48,17,red);
     setrbackcolor(33,18,48,25,black);
     setrbackcolor(49,1,64,8,black);
     setrbackcolor(49,9,64,17,blue);
     setrbackcolor(49,18,64,25,red);
     setrbackcolor(65,1,80,8,red);
     setrbackcolor(65,9,80,17,black);
     setrbackcolor(65,18,80,25,blue);
     setrbackcolor(6,6,10,20,cyan);
     setrbackcolor(10,6,32,10,cyan);
     setrbackcolor(10,17,32,20,cyan);
     setrbackcolor(33,7,34,10,cyan);
     setrbackcolor(33,16,34,19,cyan);
     setrbackcolor(35,8,36,11,cyan);
     setrbackcolor(35,15,36,18,cyan);
     setrbackcolor(37,9,44,17,cyan);
     setrbackcolor(45,8,46,11,cyan);
     setrbackcolor(45,15,46,18,cyan);
     setrbackcolor(47,7,48,10,cyan);
     setrbackcolor(47,16,48,19,cyan);
     setrbackcolor(49,6,73,9,cyan);
     setrbackcolor(49,17,73,20,cyan);
     setrbackcolor(74,7,75,8,cyan);
     setrbackcolor(74,18,75,19,cyan);
     repeat until mouseclick(klawisz,x,y) or keypressed
end;

procedure info;{strona informacyjna}
begin
     clearkeyboard;
     clear;
     hidemouse;
     textcenter(1,1,80,'INFORMACJE O PROGRAMIE',white);
     textcolor(green);
     textleft(1,3,80,'Ten program suzy do katalogowania tranzystorw bipolarnych w pliku',white);
     textleft(1,4,80,'tranzyst.dat. Program zapamituje symbol, typ, napicie kolektor-emiter, ',white);
     textleft(1,5,80,'prd kolektora, czstotliwo graniczn, obudow, cen oraz firm, w ktrej',white);
     textleft(1,6,80,'mona naby dany tranzystor za podan cen. Program wymaga zainstalowanej ',white);
     textleft(1,7,80,'myszy.',white);
     textcenter(1,9,80,'OBSUGA PROGRAMU',yellow);
     textleft(1,10,80,'Kliknicie lewym przyciskiem myszy na napisy w pierwszej linii ',white);
     textleft(1,11,80,'ekranu powoduje uruchomienie funkcji wyszukaj, dopisz lub zakoczenie programu.',white);
     textleft(1,12,80,'Kliknicie lewym przyciskiem na tytuy poszczeglnych kolumn uruchamia',white);
     textleft(1,13,80,'funkcj sortowania wg wybranego parametru (symbol, typ ...). By zmieni',white);
     textleft(1,14,80,'ktry z parametrw danego tranzystora naley klikn lewym przyciskiem',white);
     textleft(1,15,80,'w miejscu danego parametru w wierszu danego tranzystora. By zaznaczy dany',white);
     textleft(1,16,80,'tranzystor naley w klikn wierszu tranzystora w ostatniej kolumnie.',white);
     textleft(1,17,80,'Do przesuwania listy tranzystorw gra/d su strzaki po prawej stronie',white);
     textleft(1,18,80,'ekranu. Kliknicie prawym przyciskiem w wierszu tranzystora powoduje',white);
     textleft(1,19,80,'jego usunicie. Moliwe jest take ponowne wywietlenie tej strony informacyjnej',white);
     textleft(1,20,80,'oraz sortowanie wg zaznaczenia (kliknicie na odpowiedni napis na dole ekranu).',white);
     textcenter(1,25,80,'Copyright Dawid Cieszyski Iawa 2002',red);
     repeat until mouseclick(klawisz,x,y) or keypressed;
     textcolor(white);
     showmouse;
end;

procedure tranzystorwrite(tranzystor:Ttranzystor;y:byte);{zapisanie tranzystora do pliku}
var kolor:byte;
    napiecie,prad,moc,czestotliwosc,cena:string;
begin
     napiecie:='';
     prad:='';
     moc:='';
     czestotliwosc:='';
     cena:='';
     if tranzystor.napiecie<>0 then str(tranzystor.napiecie:4,napiecie);
     if tranzystor.prad<>0 then str(tranzystor.prad:6:3,prad);
     if tranzystor.moc<>0 then str(tranzystor.moc:8:4,moc);
     if tranzystor.czestotliwosc<>0 then str(tranzystor.czestotliwosc:5:0,czestotliwosc);
     if tranzystor.cena<>0 then str(tranzystor.cena:5:2,cena);
     if tranzystor.zaznaczenie=true then
        kolor:=yellow
     else
        kolor:=white;
     textleft(1,y,11,tranzystor.symbol,kolor);
     textcenter(12,y,18,tranzystor.typ,kolor);
     textcenter(19,y,26,napiecie,kolor);
     textcenter(27,y,34,prad,kolor);
     textcenter(35,y,41,moc,kolor);
     textcenter(42,y,50,czestotliwosc,kolor);
     textcenter(51,y,57,tranzystor.obudowa,kolor);
     textright(58,y,66,cena,kolor);
     textcenter(67,y,78,tranzystor.firma,kolor)
end;

procedure ramka;{ramka na rodku ekranu}
begin
     frame2(20,10,60,15,white);
     clearkeyboard;
     clrscr
end;

procedure komunikat(tekst:string);{wypisanie komunikatu w ramce}
begin
     ramka;
     write(tekst);
     repeat until mouseclick(klawisz,x,y) or keypressed
end;

procedure koniec;{koniec programu}
begin
     close(plik);
     dc;
     curon;
     clear;
     capslockoff;
     FADESONG;
     halt
end;

procedure menu;{menu gwne i wypisanie danych tranzystorw}
var y:byte;
begin
     y:=3;
     clear;
     textcenter(1,1,26,'WYSZUKAJ',cyan);
     textcenter(27,1,53,'DOPISZ',cyan);
     textcenter(54,1,80,'KONIEC',cyan);
     setchar(80,2,chr(30));
     textcenter(1,2,11,'SYMBOL',green);
     textcenter(12,2,18,'TYP',green);
     textcenter(19,2,26,'NAP.',green);
     textcenter(27,2,34,'PRD',green);
     textcenter(35,2,41,'MOC',green);
     textcenter(42,2,50,'CZST.',green);
     textcenter(51,2,57,'OBUD.',green);
     textcenter(58,2,66,'CENA',green);
     textcenter(67,2,78,'FIRMA',green);
     seek(plik,tranzystornumer);
     while not(eof(plik)) and (y < 24) do
     begin
          read(plik,tranzystor);
          tranzystorwrite(tranzystor,y);
          inc(y)
     end;
     textleft(1,25,20,'STRONA INFORMACYJNA',yellow);
     textcenter(21,25,77,'SORTOWANIE WG ZAZNACZENIA',yellow);
     setchar(80,25,chr(31))
end;

procedure odznacz; {usunicie zaznaczenia wszystkich tranzystorw}
var a:longint;
begin
     for a:=0 to filesize(plik)-1 do
     begin
          seek(plik,a);
          read(plik,tranzystor);
          tranzystor.zaznaczenie:=false;
          seek(plik,a);
          write(plik,tranzystor)
     end;
end;

procedure szukajsymb;
var symb:Tsymbol;
    a:longint;
    b:byte;
begin
    ramka;
    write('szukany symbol:');
    curon;
    readln(symb);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         b:=pos(symb,tranzystor.symbol);
         if b<>0 then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure szukajtyp;
var typ:Ttyp;
    a:longint;
    b:byte;
begin
    ramka;
    write('szukany typ:');
    curon;
    readln(typ);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         b:=pos(typ,tranzystor.typ);
         if b<>0 then begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
            end
    end
end;

procedure szukajnapiecie;
var napiecie:Tnapiecie;
    a:longint;
begin
    ramka;
    write('szukane napicie:');
    curon;
    readln(napiecie);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         if napiecie=tranzystor.napiecie then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure szukajprad;
var prad:Tprad;
    a:longint;
begin
    ramka;
    write('szukany prd:');
    curon;
    readln(prad);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         if prad=tranzystor.prad then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure szukajmoc;
var moc:Tmoc;
    a:longint;
begin
    ramka;
    write('szukana moc:');
    curon;
    readln(moc);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         if moc=tranzystor.moc then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure szukajczestotliwosc;
var czestotliwosc:Tczestotliwosc;
    a:longint;
begin
    ramka;
    write('szukana czstotliwo:');
    curon;
    readln(czestotliwosc);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         if czestotliwosc=tranzystor.czestotliwosc then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure szukajobudowa;
var obudowa:Tobudowa;
    a:longint;
    b:byte;
begin
    ramka;
    write('szukana obudowa:');
    curon;
    readln(obudowa);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         b:=pos(obudowa,tranzystor.obudowa);
         if b<>0 then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure szukajcena;
var cena:Tcena;
    a:longint;
begin
    ramka;
    write('szukana cena:');
    curon;
    readln(cena);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         if cena=tranzystor.cena then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure szukajfirma;
var firma:Tfirma;
    a:longint;
    b:byte;
begin
    ramka;
    write('szukana firma:');
    curon;
    readln(firma);
    curoff;
    for a:=0 to filesize(plik)-1 do
    begin
         seek(plik,a);
         read(plik,tranzystor);
         b:=pos(firma,tranzystor.firma);
         if b<>0 then
         begin
            seek(plik,a);
            tranzystor.zaznaczenie:=true;
            write(plik,tranzystor);
         end
    end
end;

procedure sortuj;{sortowanie wg zaznaczenia}
var pom:Ttranzystor;
    i,a:longint;
begin
     i:=0;
     repeat
           seek(plik,i);
           read(plik,tranzystor);
           if tranzystor.zaznaczenie=false then
              begin
                   a:=i+1;
                   repeat
                         seek(plik,a);
                         read(plik,tranzystor);
                         if tranzystor.zaznaczenie=true then
                         begin
                              seek(plik,i);
                              read(plik,pom);
                              seek(plik,i);
                              write(plik,tranzystor);
                              seek(plik,a);
                              write(plik,pom);
                         end;
                         inc(a);
                   until (a>=filesize(plik)) or (tranzystor.zaznaczenie=true);
              end;
           inc (i);
     until (i=filesize(plik)) or (a=filesize(plik))
end;

procedure wyszukaj;
begin
odznacz;
for y:=3 to 24 do textcenter(1,y,80,'',white);
    textcenter(1,1,80,' WYBIERZ KATEGORI',WHITE);
    repeat until mouseclick(klawisz,x,y);
    case klawisz of
         1:if y=2 then case x of
                  1..11:szukajsymb;
                  12..18:szukajtyp;
                  19..26:szukajnapiecie;
                  27..34:szukajprad;
                  35..41:szukajmoc;
                  42..50:szukajczestotliwosc;
                  51..57:szukajobudowa;
                  58..66:szukajcena;
                  67..77:szukajfirma;
                  end;
         2:info;
    end;
    sortuj;
    tranzystornumer:=0;
end;

procedure dopisz;
begin
     tranzystor.zaznaczenie:=false;
     textcolor(white);
     textbackground(black);
     seek(plik,filesize(plik));
     curon;
     ramka;
     write('symbol:');
     readln(tranzystor.symbol);if tranzystor.symbol='' then tranzystor.symbol:='';
     ramka;
     write('typ:');
     readln(tranzystor.typ);if tranzystor.typ='' then tranzystor.typ:='';
     ramka;
     write('napicie emiter-kolektor:');
     readln(tranzystor.napiecie);
     ramka;
     write('prd kolektora:');
     readln(tranzystor.prad);
     ramka;
     write('moc:');
     readln(tranzystor.moc);
     ramka;
     write('czstotliwo graniczna:');
     readln(tranzystor.czestotliwosc);
     ramka;
     write('obudowa:');
     readln(tranzystor.obudowa);if tranzystor.obudowa='' then tranzystor.obudowa:='';
     ramka;
     write('cena:');
     readln(tranzystor.cena);
     ramka;
     write('firma:');
     readln(tranzystor.firma);if tranzystor.firma='' then tranzystor.firma:='';
     curoff;
     seek(plik,filesize(plik));
     write(plik,tranzystor);
     clear;
end;

procedure zmniejsztr;{przesunicie listy tranzystorw w d}
begin
     if tranzystornumer>0 then dec(tranzystornumer);
end;

procedure zmiensymbol(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj symbol:');
          curon;
          readln(tranzystor.symbol);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmientyp(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj typ:');
          curon;
          readln(tranzystor.typ);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmiennapiecie(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj napicie emiter-kolektor:');
          curon;
          readln(tranzystor.napiecie);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmienprad(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj prd kolektora:');
          curon;
          readln(tranzystor.prad);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmienmoc(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj moc:');
          curon;
          readln(tranzystor.moc);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmienczestotliwosc(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj czstotliwo:');
          curon;
          readln(tranzystor.czestotliwosc);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmienobudowa(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj obudow:');
          curon;
          readln(tranzystor.obudowa);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmiencena(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj cen:');
          curon;
          readln(tranzystor.cena);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zmienfirma(numer:longint);
begin
     if numer<filesize(plik) then
     begin
          ramka;
          seek(plik,numer);
          read(plik,tranzystor);
          write('podaj firm:');
          curon;
          readln(tranzystor.firma);
          curoff;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure zaznacz (numer:longint);{zaznaczenie tranzystora}
begin
     if numer<filesize(plik) then
     begin
          seek(plik,numer);
          read(plik,tranzystor);
          tranzystor.zaznaczenie:=not tranzystor.zaznaczenie;
          seek(plik,numer);
          write(plik,tranzystor);
     end;
end;

procedure usun(numer:longint);{usunicie tranzystora}
var a:longint;
begin
     if numer<filesize(plik) then
     begin
          for a:= numer to filesize(plik)-2 do
          begin
                  seek(plik,a+1);
                  read(plik,tranzystor);
                  seek(plik,a);
                  write(plik,tranzystor);
          end;
          seek(plik,filesize(plik)-1);
          truncate(plik);
     end;
end;

procedure zwieksztr;{przesunicie listy tranzystorw w gr}
begin
     if tranzystornumer<filesize(plik)-1 then inc(tranzystornumer);
end;

procedure symbolsort;
var symbol:Tsymbol;
    pom:Ttranzystor;
    numer,a,b:longint;
    c:byte;
    d:boolean;
begin
     for a:=0 to filesize(plik)-2 do
     begin
          seek(plik,a);
          read(plik,tranzystor);
          symbol:=tranzystor.symbol;
          numer:=a;
          for b:=a+1 to filesize(plik)-1 do
          begin
               seek(plik,b);
               read(plik,tranzystor);
               c:=1;
               repeat
                     d:=false;
                     if ord(symbol[c])>ord(tranzystor.symbol[c]) then
                        begin
                             symbol:=tranzystor.symbol;
                             numer:=b;
                             d:=true;
                        end
                        else
                            if ord(symbol[c])<ord(tranzystor.symbol[c]) then d:=true;
                     inc(c);
               until ((c=10) or (d=true));
          end;
          seek(plik,numer);
          read(plik,pom);
          seek(plik,a);
          read(plik,tranzystor);
          seek(plik,numer);
          write(plik,tranzystor);
          seek(plik,a);
          write(plik,pom)
     end;
end;

procedure typsort;
var typ:Ttyp;
    pom:Ttranzystor;
    numer,a,b:longint;
    c:byte;
    d:boolean;
begin
     for a:=0 to filesize(plik)-2 do
     begin
          seek(plik,a);
          read(plik,tranzystor);
          typ:=tranzystor.typ;
          numer:=a;
          for b:=a+1 to filesize(plik)-1 do
          begin
               seek(plik,b);
               read(plik,tranzystor);
               c:=1;
               repeat
                     d:=false;
                     if ord(typ[c])>ord(tranzystor.typ[c]) then
                            begin
                                 typ:=tranzystor.typ;
                                 numer:=b;
                                 d:=true;
                            end;
                     if ord(typ[c])<ord(tranzystor.typ[c]) then  d:=true;
                     inc(c);
               until ((c=3) or (d=true));
          end;
          seek(plik,numer);
          read(plik,pom);
          seek(plik,a);
          read(plik,tranzystor);
          seek(plik,numer);
          write(plik,tranzystor);
          seek(plik,a);
          write(plik,pom)
     end;
end;

procedure napieciesort;
var napiecie:Tnapiecie;
    a,i,numer:longint;
    pom:Ttranzystor;
begin
     for i:=0 to filesize(plik)-1 do
     begin
          seek(plik,i);
          read(plik,tranzystor);
          napiecie:=tranzystor.napiecie;
          numer:=i;
          for a:=i+1 to filesize(plik)-1 do
          begin
               seek(plik,a);
               read(plik,tranzystor);
               if napiecie>tranzystor.napiecie then
               begin
                    napiecie:=tranzystor.napiecie;
                    numer:=a;
               end;
          end;
          seek(plik,i);
          read(plik,pom);
          seek(plik,numer);
          read(plik,tranzystor);
          seek(plik,i);
          write(plik,tranzystor);
          seek(plik,numer);
          write(plik,pom)
     end
end;

procedure pradsort;
var prad:Tprad;
    a,i,numer:longint;
    pom:Ttranzystor;
begin
     for i:=0 to filesize(plik)-1 do
     begin
          seek(plik,i);
          read(plik,tranzystor);
          prad:=tranzystor.prad;
          numer:=i;
          for a:=i+1 to filesize(plik)-1 do
          begin
               seek(plik,a);
               read(plik,tranzystor);
               if prad>tranzystor.prad then
               begin
                    prad:=tranzystor.prad;
                    numer:=a;
               end;
          end;
          seek(plik,i);
          read(plik,pom);
          seek(plik,numer);
          read(plik,tranzystor);
          seek(plik,i);
          write(plik,tranzystor);
          seek(plik,numer);
          write(plik,pom)
     end
end;

procedure mocsort;
var moc:Tmoc;
    a,i,numer:longint;
    pom:Ttranzystor;
begin
     for i:=0 to filesize(plik)-1 do
     begin
          seek(plik,i);
          read(plik,tranzystor);
          moc:=tranzystor.moc;
          numer:=i;
          for a:=i+1 to filesize(plik)-1 do
          begin
               seek(plik,a);
               read(plik,tranzystor);
               if moc>tranzystor.moc then
               begin
                    moc:=tranzystor.moc;
                    numer:=a;
               end;
          end;
          seek(plik,i);
          read(plik,pom);
          seek(plik,numer);
          read(plik,tranzystor);
          seek(plik,i);
          write(plik,tranzystor);
          seek(plik,numer);
          write(plik,pom)
     end
end;

procedure czestotliwoscsort;
var czestotliwosc:Tczestotliwosc;
    a,i,numer:longint;
    pom:Ttranzystor;
begin
     for i:=0 to filesize(plik)-1 do
     begin
          seek(plik,i);
          read(plik,tranzystor);
          czestotliwosc:=tranzystor.czestotliwosc;
          numer:=i;
          for a:=i+1 to filesize(plik)-1 do
          begin
               seek(plik,a);
               read(plik,tranzystor);
               if czestotliwosc>tranzystor.czestotliwosc then
               begin
                    czestotliwosc:=tranzystor.czestotliwosc;
                    numer:=a;
               end;
          end;
          seek(plik,i);
          read(plik,pom);
          seek(plik,numer);
          read(plik,tranzystor);
          seek(plik,i);
          write(plik,tranzystor);
          seek(plik,numer);
          write(plik,pom)
     end
end;

procedure obudowasort;
var obudowa:Tobudowa;
    pom:Ttranzystor;
    numer,a,b:longint;
    c:byte;
    d:boolean;
begin
     for a:=0 to filesize(plik)-2 do
     begin
          seek(plik,a);
          read(plik,tranzystor);
          obudowa:=tranzystor.obudowa;
          numer:=a;
          for b:=a+1 to filesize(plik)-1 do
          begin
               seek(plik,b);
               read(plik,tranzystor);
               c:=1;
               repeat
                     d:=false;
                     if ord(obudowa[c])>ord(tranzystor.obudowa[c]) then
                        begin
                             obudowa:=tranzystor.obudowa;
                             numer:=b;
                             d:=true;
                        end;
                        if ord(obudowa[c])<ord(tranzystor.obudowa[c]) then d:=true;
                     inc(c);
               until ((c=5) or (d=true));
          end;
          seek(plik,numer);
          read(plik,pom);
          seek(plik,a);
          read(plik,tranzystor);
          seek(plik,numer);
          write(plik,tranzystor);
          seek(plik,a);
          write(plik,pom)
     end;
end;

procedure cenasort;
var cena:Tcena;
    a,i,numer:longint;
    pom:Ttranzystor;
begin
     for i:=0 to filesize(plik)-1 do
     begin
          seek(plik,i);
          read(plik,tranzystor);
          cena:=tranzystor.cena;
          numer:=i;
          for a:=i+1 to filesize(plik)-1 do
          begin
               seek(plik,a);
               read(plik,tranzystor);
               if cena>tranzystor.cena then
               begin
                    cena:=tranzystor.cena;
                    numer:=a;
               end
          end;
          seek(plik,i);
          read(plik,pom);
          seek(plik,numer);
          read(plik,tranzystor);
          seek(plik,i);
          write(plik,tranzystor);
          seek(plik,numer);
          write(plik,pom);
     end
end;

procedure firmasort;
var firma:Tfirma;
    pom:Ttranzystor;
    numer,a,b:longint;
    c:byte;
    d:boolean;
begin
     for a:=0 to filesize(plik)-2 do
     begin
          seek(plik,a);
          read(plik,tranzystor);
          firma:=tranzystor.firma;
          numer:=a;
          for b:=a+1 to filesize(plik)-1 do
          begin
               seek(plik,b);
               read(plik,tranzystor);
               c:=1;
               repeat
                     d:=false;
                     if ord(firma[c])>ord(tranzystor.firma[c]) then
                        begin
                             firma:=tranzystor.firma;
                             numer:=b;
                             d:=true;
                        end;
                        if ord(firma[c])<ord(tranzystor.firma[c]) then d:=true;
                     inc(c);
               until ((c=10) or (d=true));
          end;
          seek(plik,numer);
          read(plik,pom);
          seek(plik,a);
          read(plik,tranzystor);
          seek(plik,numer);
          write(plik,tranzystor);
          seek(plik,a);
          write(plik,pom)
     end;
end;


{PROGRAM GWNY}
begin
     LOADSONG('MUSIC6.HSC');
     PLAYSONG;
     curoff;
     capslockon;
     dc;
     showmouse;
     tranzystornumer:=0;
     window(22,12,58,13);
     clear;
     if not ismouse then
     begin
          komunikat('Program wymaga zainstalowania myszy');
          halt;
     end;
     assign(plik,'tranzyst.dat');
     reset(plik);
     if ioresult<>0 then rewrite(plik);
     if ioresult<>0 then
     begin
          komunikat('Problem z (o)tworzeniem pliku tranzyst.dat');
          halt;
     end;
     info;
     repeat
           menu;
           repeat until mouseclick(klawisz,x,y);
           case klawisz of
                1: case y of
                        1:case x of
                               1..26:wyszukaj;
                               27..53:dopisz;
                               54..80:koniec;
                        end;
                        2:case x of
                               1..11:symbolsort;
                               12..18:typsort;
                               19..26:napieciesort;
                               27..34:pradsort;
                               35..41:mocsort;
                               42..50:czestotliwoscsort;
                               51..57:obudowasort;
                               58..66:cenasort;
                               67..77:firmasort;
                               78..80:zmniejsztr;
                        end;
                        3..23: case x of
                                    1..11:zmiensymbol(tranzystornumer+y-3);
                                    12..18:zmientyp(tranzystornumer+y-3);
                                    19..26:zmiennapiecie(tranzystornumer+y-3);
                                    27..34:zmienprad(tranzystornumer+y-3);
                                    35..41:zmienmoc(tranzystornumer+y-3);
                                    42..50:zmienczestotliwosc(tranzystornumer+y-3);
                                    51..57:zmienobudowa(tranzystornumer+y-3);
                                    58..66:zmiencena(tranzystornumer+y-3);
                                    67..77:zmienfirma(tranzystornumer+y-3);
                                    78..80:zaznacz(tranzystornumer+y-3);
                        end;
                        25:case x of
                                1..20:info;
                                21..77:sortuj;
                                78..80:zwieksztr
                        end;
                 end;
                 2:if y in [3..24] then usun(tranzystornumer+y-3)
                 else info
                 end;
           until false
end.